#version 150

#moj_import <fog.glsl>
#moj_import <light.glsl>

in vec3 Position;
in vec2 UV0;
in vec4 Color;
in ivec2 UV2;

uniform sampler2D Sampler2;
uniform sampler2D Sampler0;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;

out float vertexDistance;
out vec2 texCoord0;
out vec4 vertexColor;

#moj_import <shader_utils.glsl>

void main() {
    float alpha = texture(Sampler0, UV0).a * 255.0;
    float angle = radians(15.0);
    mat3 rotationMatrix = mat3(
        cos(angle), -sin(angle), 0.0,
        sin(angle),  cos(angle), 0.0,
        0.0,        0.0,        1.0
    );
    vec3 rotatedPosition;
    
    if(alpha == 2){
        rotatedPosition = rotationMatrix * Position;
        vertexColor = Color * minecraft_sample_lightmap(Sampler2, UV2) * vec4(1.6, 1.6, 1.6, 1);
    }else{
        rotatedPosition = Position;
        vertexColor = getCherryBiomeColor(Color) * minecraft_sample_lightmap(Sampler2, UV2);
    }

    gl_Position = ProjMat * ModelViewMat * vec4(rotatedPosition, 1.0);
    vertexDistance = fog_distance(ModelViewMat, Position, FogShape);
    texCoord0 = UV0;
}
