#version 150

#moj_import <fog.glsl>
#moj_import <shader_utils.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in vec4 lightmapColor;
in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec4 normal;
in float object;

out vec4 fragColor;

void main() {

    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator * lightmapColor;
    float alpha = texture(Sampler0, texCoord0).a * 255.0;

    float nightness = length(lightmapColor.xyz - vec3(39, 39, 64) / 255);
    nightness = smoothstep(0.08, 0.4, nightness);

    if(alpha == 253){
        if(vertexDistance < 50){
            color = mix(vec4(texture(Sampler0, texCoord0).xyz, 1), vec4(texture(Sampler0, texCoord0).xyz, 0), nightness);
        }else{
            color = vec4(0, 0, 0, 0);
        }
    }

    if(alpha == 254){
        color = texture(Sampler0, texCoord0);
    }

    if (color.a < 0.1) {
        discard;
    }

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
